SystemOrganization addCategory: #Poo!

Object subclass: #BancoDeDados
	instanceVariableNames: 'cursos usuarios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!BancoDeDados commentStamp: 'FA 5/12/2013 18:47' prior: 0!
Banco que guarda cursos, usuarios e atraves dela que pesquisas sao feitas!

!BancoDeDados methodsFor: 'adicionando' stamp: 'tgn 5/12/2013 17:21'!
adicionaCurso: curso
	
	^cursos add: curso! !

!BancoDeDados methodsFor: 'adicionando' stamp: 'FA 5/12/2013 13:33'!
adicionaUsuario: usuario

	^usuarios add: (usuario login), '#',(usuario senha) -> usuario! !

!BancoDeDados methodsFor: 'acessando' stamp: 'tgn 5/12/2013 17:22'!
curso
	^ cursos! !

!BancoDeDados methodsFor: 'acessando' stamp: 'tgn 5/12/2013 17:21'!
devolveCursosDeNome: nome 

	| res |
	res := Set new.
	cursos do: [ :curso  |  ((curso nome) = nome) 
		                               ifTrue: [ res add: curso ] ].
	^ res	 
	! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:36'!
devolveDisciplinasDeNome: nome
	| res |
	res := Set new.
	cursos do: [ :curso  |  (curso disciplinas) do: 
			     					[ :disciplina | ((disciplina nome) = nome) 
		                              					 ifTrue: [ res add: disciplina ] 
							      ]
	                 ].
	^ res	 ! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 17:43'!
devolveUsuarioDeLogin: login eSenha: senha

	[ ^ usuarios at: (login,'#',senha) ]
	on: Exception
	do: [ ^ nil. ]	 
	! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:02'!
devolveUsuariosDeNome: nome
	| res |
	res := Set new.
	usuarios do: [ :usuario  |  ((usuario nome) = nome) 
		                               ifTrue: [ res add: usuario ] ].
	^ res	 ! !

!BancoDeDados methodsFor: 'inicializando' stamp: 'tgn 5/12/2013 17:22'!
initialize
	cursos := Set new.
	usuarios := Dictionary new.
	^self! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 16:28'!
usuarios
	^ usuarios! !

Object subclass: #Conteudo
	instanceVariableNames: 'tipo titulo descricao resumo autor referencia classificacao tags dataDeCriacao dataDeModificacao licenca dono texto listaDeNotas listaDeNotasModerador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Conteudo commentStamp: 'FA 5/12/2013 18:46' prior: 0!
Representa um conteudo no nosso sistema !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:05'!
adicionaNota: nota
	"Adiciona nota para esse conteudo"
	
	listaDeNotas add: nota! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:05'!
adicionaNotamoderador: nota
	"Adiciona nota para esse conteudo"
	
	listaDeNotasModerador add: nota! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
autor
	"Answer the value of autor"

	^ autor! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
autor: anObject
	"Set the value of autor"

	autor := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
classificacao
	"Answer the value of classificacao"

	^ classificacao! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
classificacao: anObject
	"Set the value of classificacao"

	classificacao := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dataDeCriacao
	"Answer the value of dataDeCriacao"

	^ dataDeCriacao! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dataDeCriacao: anObject
	"Set the value of dataDeCriacao"

	dataDeCriacao := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dataDeModificacao
	"Answer the value of dataDeModificacao"

	^ dataDeModificacao! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dataDeModificacao: anObject
	"Set the value of dataDeModificacao"

	dataDeModificacao := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
descricao
	"Answer the value of descricao"

	^ descricao! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
descricao: anObject
	"Set the value of descricao"

	descricao := anObject! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 16:48'!
devolveTexto
	^ texto ! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dono
	"Answer the value of dono"

	^ dono! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
dono: anObject
	"Set the value of dono"

	dono := anObject! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 18:45'!
initialize
	listaDeNotas := Set new.
	listaDeNotasModerador := Set new.
	tags := Set new.
	^self! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
licenca
	"Answer the value of licenca"

	^ licenca! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
licenca: anObject
	"Set the value of licenca"

	licenca := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
listaDeNotas
	"Answer the value of listaDeNotas"

	^ listaDeNotas! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
listaDeNotas: anObject
	"Set the value of listaDeNotas"

	listaDeNotas := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
listaDeNotasModerador
	"Answer the value of listaDeNotasModerador"

	^ listaDeNotasModerador! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
listaDeNotasModerador: anObject
	"Set the value of listaDeNotasModerador"

	listaDeNotasModerador := anObject! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:14'!
mediaDasNotas
	"Adiciona nota para esse conteudo"
	
	| total |
	total := 0.
	listaDeNotas do: [ :conteudo | total := total + conteudo. ].
	^ total / listaDeNotas size.! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:14'!
mediaDasNotasModerador
	"Adiciona nota para esse conteudo"
	
	| total |
	total := 0.
	listaDeNotasModerador do: [ :conteudo | total := total + conteudo. ].
	^ total / listaDeNotasModerador size.! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
referencia
	"Answer the value of referencia"

	^ referencia! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
referencia: anObject
	"Set the value of referencia"

	referencia := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
resumo
	"Answer the value of resumo"

	^ resumo! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
resumo: anObject
	"Set the value of resumo"

	resumo := anObject! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 16:48'!
salvaTexto: string
	^ texto := string! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
tags
	"Answer the value of tags"

	^ tags! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
texto
	"Answer the value of texto"

	^ texto! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
texto: anObject
	"Set the value of texto"

	texto := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
tipo
	"Answer the value of tipo"

	^ tipo! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
tipo: anObject
	"Set the value of tipo"

	tipo := anObject! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
titulo
	"Answer the value of titulo"

	^ titulo! !

!Conteudo methodsFor: 'acessando' stamp: 'FA 5/12/2013 19:17'!
titulo: anObject
	"Set the value of titulo"

	titulo := anObject! !

Object subclass: #Sistema
	instanceVariableNames: 'admin bancoDeDados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Sistema commentStamp: 'tgn 5/11/2013 15:59' prior: 0!
Classe de acesso ao sistema!

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 15:57'!
acessarComNome: nomeAdmin eSenha: senhaAdmin
	"Tenta acessar o sistema"

	('admin' compare: nomeAdmin) = 2
		ifTrue: [ ^ ('admin' compare: senhaAdmin) = 2 ]
		ifFalse: [ ^ false ].
					
		! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:32'!
adicionaAluno: aluno naTurma: turma! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
adicionaConteudo: conteudo naAula: aula! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
adicionarModerador: moderador noCurso: curso! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:34'!
avaliarConteudo: conteudo peloUsuario: usuario comNota:nota! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
criarAulaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplina: disciplina! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
criarCursoComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
criarDisciplinaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores noCurso: curso! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
criarTurmaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplina: disciplina! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:29'!
criarUsuario: nome comSenha: senha eLogin: login! !

!Sistema methodsFor: 'initialize-release' stamp: 'tgn 5/12/2013 19:47'!
initialize
	admin := Admin new.
	bancoDeDados := BancoDeDados new.
	^self! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:30'!
usuario: nome agoraModeraOTopico: topico! !

Object subclass: #Topico
	instanceVariableNames: 'nome dataDeCriacao descricao responsavel moderadores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Topico commentStamp: 'HGPL 5/11/2013 15:49' prior: 0!
Classe base para elementos do sistema!

Topico subclass: #Aula
	instanceVariableNames: 'materiais'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Aula commentStamp: 'HGPL 5/11/2013 16:05' prior: 0!
Uma Aula do sistema!

Topico subclass: #Curso
	instanceVariableNames: 'disciplinas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Curso commentStamp: 'HGPL 5/11/2013 16:01' prior: 0!
Um Curso do sistema.!

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:58'!
adicionaDisciplina: umaDisciplina
	"Adiciona uma disciplina ao curso"! !

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
disciplinas
	"Answer the value of disciplinas"

	^ disciplinas! !

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:58'!
removeDisciplina: umaDisciplina
	"Remove uma disciplina do curso"! !

Topico subclass: #Disciplina
	instanceVariableNames: 'aulas turmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Disciplina commentStamp: 'HGPL 5/11/2013 16:03' prior: 0!
Uma Disciplina do sistema!

!Disciplina methodsFor: 'adicionando' stamp: 'FA 5/12/2013 18:28'!
adicionaAula: aula
	^aulas add: aula! !

!Disciplina methodsFor: 'adicionando' stamp: 'FA 5/12/2013 18:28'!
adicionaTurma: turma
	^turmas add: turma! !

!Disciplina methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:30'!
aulas
	^aulas! !

!Disciplina methodsFor: 'inicializando' stamp: 'FA 5/12/2013 18:27'!
initialize
	aulas := Set new.
	turmas := Set new.
	^self! !

!Disciplina methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:29'!
turmas
	^turmas! !

!Topico methodsFor: 'primitivas' stamp: 'HGPL 5/11/2013 17:49'!
adicionaModerador: umModerador
	"Adiciona um moderador ao Tpico"

	^ moderadores add: umModerador! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
dataDeCriacao
	"Answer the value of dataDeCriacao"

	^ dataDeCriacao! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
dataDeCriacao: anObject
	"Set the value of dataDeCriacao"

	dataDeCriacao := anObject! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
descricao
	"Answer the value of descricao"

	^ descricao! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
descricao: anObject
	"Set the value of descricao"

	descricao := anObject! !

!Topico methodsFor: 'primitivas' stamp: 'HGPL 5/11/2013 17:44'!
eModerador: umUsuario
	"Verifica se um usurio  um moderador nesse tpico"

	^ moderadores includes: umUsuario! !

!Topico methodsFor: 'inicializando' stamp: 'FA 5/12/2013 18:06'!
initialize
	"Inicializa o Tpico"
	nome := 'Tpico sem-nome'.
	dataDeCriacao := DateAndTime now.
	moderadores := Set new.
	^self! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
moderadores
	"Answer the value of moderadores"

	^ moderadores! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
nome
	"Answer the value of nome"

	^ nome! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
nome: anObject
	"Set the value of nome"

	nome := anObject! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
responsavel
	"Answer the value of responsavel"

	^ responsavel! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
responsavel: anObject
	"Set the value of responsavel"

	responsavel := anObject! !

Topico subclass: #Turma
	instanceVariableNames: 'alunos instrutor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Turma commentStamp: 'HGPL 5/11/2013 16:06' prior: 0!
Uma turma do sistema!

!Turma methodsFor: 'adicionando' stamp: 'FA 5/12/2013 18:25'!
adicionaAluno: usuario
	^alunos add: usuario! !

!Turma methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:26'!
alunos
	^alunos
	
	! !

!Turma methodsFor: 'inicializando' stamp: 'FA 5/12/2013 18:22'!
initialize
	alunos := Set new.
	^self! !

!Turma methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:24'!
instrutor
	^instrutor
	! !

!Turma methodsFor: 'acessando' stamp: 'FA 5/12/2013 18:24'!
instrutor: usuario
	^instrutor:=usuario
	
	! !

Object subclass: #Usuario
	instanceVariableNames: 'nome login senha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Usuario commentStamp: 'tgn 5/11/2013 15:15' prior: 0!
Classe de usuario!

Usuario subclass: #Admin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Admin commentStamp: 'tgn 5/11/2013 17:15' prior: 0!
Classe de administrador.!

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:42'!
criarConteudo: infoConteudo
	"cria um conteudo generico"
	
	| novoConteudo |
	
	novoConteudo := Conteudo new.
	novoConteudo salvaTexto: infoConteudo.
	^ novoConteudo.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:43'!
criarTopico: nomeTopico comDescricao: descricao

	| topico |
	
	topico := Topico new.
	topico init.
	topico nome: nomeTopico.
	topico descricao: descricao.
	^ topico.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:26'!
criarUsuarioComNome: nomeNovo eSenha: senhaNovo eLogin: loginNovo
	"cria um conteudo generico"
	
	| usuario |
	usuario := Usuario new.
	^ usuario inicializaUsuarioComNome: nomeNovo eSenha: senhaNovo eLogin: loginNovo.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:22'!
deletaConteudo: conteudoASerDeletado
	"deleta um conteudo generico"! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:29'!
deletaTopico: topico! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:28'!
deletarUsuarioComLogin: loginDoDeletado
	"Deleta um usuario"! !

!Admin methodsFor: 'initialize-release' stamp: 'FA 5/12/2013 18:10'!
initialize
	login := 'admin'.
	senha := 'admin'.
	nome := 'admin'.
	^self! !

Usuario subclass: #Moderador
	instanceVariableNames: 'topicosQueModera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Moderador commentStamp: 'tgn 5/11/2013 16:20' prior: 0!
Classe do moderador!

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 16:36'!
adicionaNovoTopico: topico
	"Adiciona novo topico para ser moderado"

	topicosQueModera add: topico.! !

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:06'!
deletaConteudo: conteudoASerDeletado
	"Adiciona novo topico para ser moderado"

! !

!Moderador methodsFor: 'inicializando' stamp: 'FA 5/12/2013 18:10'!
initialize
	"Inicia a Classe"
	topicosQueModera := Set new.
	^self! !

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:01'!
verificaSeModeraOTopico: topico
	"Verifica se esse moderador modera o topico passado"

	^ topicosQueModera includes: topico.! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:11'!
avaliaConteudo: conteudoASerAvaliado notaDada: notaDada
	"Adiciona novo topico para ser moderado"
! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:11'!
consultarConteudo: conteudoASerConsultado
	"Adiciona novo topico para ser moderado"
! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:14'!
criarConteudo: infoDoConteudo
	"Cria um novo conteudo"! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:13'!
delegarPoderAoUsuario: usuario noTopico: topico
	"Inseri usuario com poder de moderador no topico alvo"! !

!Usuario methodsFor: 'inicializando' stamp: 'FA 5/12/2013 18:11'!
inicializaUsuarioComNome: novoNome eSenha: novaSenha eLogin: novoLogin
	"comment stating purpose of message"

	nome := novoNome.
	senha := novaSenha.
	login := novoLogin.
	^self
	! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:12'!
inserirInformacoes: informacoes noTopico: topico
	"Inseri informacoes no topico alvo"! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
login
	"login"

	^ login! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
login: novoLogin
	"login"

	login := novoLogin! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:31'!
nome
	"nome"

	^ nome! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:33'!
nome: novoNome
	"nome"

	nome := novoNome! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
senha
	"senha"

	^ senha! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
senha: novaSenha
	"senha"

	senha := novaSenha! !
